// automatically generated by the FlatBuffers compiler, do not modify

package Serialization;

import java.nio.*;
import java.lang.*;
import java.util.*;
import com.google.flatbuffers.*;

@SuppressWarnings("unused")
public final class TreeNode extends Table {
  public static void ValidateVersion() { Constants.FLATBUFFERS_1_12_0(); }
  public static TreeNode getRootAsTreeNode(ByteBuffer _bb) { return getRootAsTreeNode(_bb, new TreeNode()); }
  public static TreeNode getRootAsTreeNode(ByteBuffer _bb, TreeNode obj) { _bb.order(ByteOrder.LITTLE_ENDIAN); return (obj.__assign(_bb.getInt(_bb.position()) + _bb.position(), _bb)); }
  public void __init(int _i, ByteBuffer _bb) { __reset(_i, _bb); }
  public TreeNode __assign(int _i, ByteBuffer _bb) { __init(_i, _bb); return this; }

  public int uid() { int o = __offset(4); return o != 0 ? bb.getShort(o + bb_pos) & 0xFFFF : 0; }
  public int childrenUid(int j) { int o = __offset(6); return o != 0 ? bb.getShort(__vector(o) + j * 2) & 0xFFFF : 0; }
  public int childrenUidLength() { int o = __offset(6); return o != 0 ? __vector_len(o) : 0; }
  public ShortVector childrenUidVector() { return childrenUidVector(new ShortVector()); }
  public ShortVector childrenUidVector(ShortVector obj) { int o = __offset(6); return o != 0 ? obj.__assign(__vector(o), bb) : null; }
  public ByteBuffer childrenUidAsByteBuffer() { return __vector_as_bytebuffer(6, 2); }
  public ByteBuffer childrenUidInByteBuffer(ByteBuffer _bb) { return __vector_in_bytebuffer(_bb, 6, 2); }
  public byte status() { int o = __offset(8); return o != 0 ? bb.get(o + bb_pos) : 0; }
  public String instanceName() { int o = __offset(10); return o != 0 ? __string(o + bb_pos) : null; }
  public ByteBuffer instanceNameAsByteBuffer() { return __vector_as_bytebuffer(10, 1); }
  public ByteBuffer instanceNameInByteBuffer(ByteBuffer _bb) { return __vector_in_bytebuffer(_bb, 10, 1); }
  public String registrationName() { int o = __offset(12); return o != 0 ? __string(o + bb_pos) : null; }
  public ByteBuffer registrationNameAsByteBuffer() { return __vector_as_bytebuffer(12, 1); }
  public ByteBuffer registrationNameInByteBuffer(ByteBuffer _bb) { return __vector_in_bytebuffer(_bb, 12, 1); }
  public Serialization.PortConfig portRemaps(int j) { return portRemaps(new Serialization.PortConfig(), j); }
  public Serialization.PortConfig portRemaps(Serialization.PortConfig obj, int j) { int o = __offset(14); return o != 0 ? obj.__assign(__indirect(__vector(o) + j * 4), bb) : null; }
  public int portRemapsLength() { int o = __offset(14); return o != 0 ? __vector_len(o) : 0; }
  public Serialization.PortConfig.Vector portRemapsVector() { return portRemapsVector(new Serialization.PortConfig.Vector()); }
  public Serialization.PortConfig.Vector portRemapsVector(Serialization.PortConfig.Vector obj) { int o = __offset(14); return o != 0 ? obj.__assign(__vector(o), 4, bb) : null; }

  public static int createTreeNode(FlatBufferBuilder builder,
      int uid,
      int children_uidOffset,
      byte status,
      int instance_nameOffset,
      int registration_nameOffset,
      int port_remapsOffset) {
    builder.startTable(6);
    TreeNode.addPortRemaps(builder, port_remapsOffset);
    TreeNode.addRegistrationName(builder, registration_nameOffset);
    TreeNode.addInstanceName(builder, instance_nameOffset);
    TreeNode.addChildrenUid(builder, children_uidOffset);
    TreeNode.addUid(builder, uid);
    TreeNode.addStatus(builder, status);
    return TreeNode.endTreeNode(builder);
  }

  public static void startTreeNode(FlatBufferBuilder builder) { builder.startTable(6); }
  public static void addUid(FlatBufferBuilder builder, int uid) { builder.addShort(0, (short)uid, (short)0); }
  public static void addChildrenUid(FlatBufferBuilder builder, int childrenUidOffset) { builder.addOffset(1, childrenUidOffset, 0); }
  public static int createChildrenUidVector(FlatBufferBuilder builder, short[] data) { builder.startVector(2, data.length, 2); for (int i = data.length - 1; i >= 0; i--) builder.addShort(data[i]); return builder.endVector(); }
  public static void startChildrenUidVector(FlatBufferBuilder builder, int numElems) { builder.startVector(2, numElems, 2); }
  public static void addStatus(FlatBufferBuilder builder, byte status) { builder.addByte(2, status, 0); }
  public static void addInstanceName(FlatBufferBuilder builder, int instanceNameOffset) { builder.addOffset(3, instanceNameOffset, 0); }
  public static void addRegistrationName(FlatBufferBuilder builder, int registrationNameOffset) { builder.addOffset(4, registrationNameOffset, 0); }
  public static void addPortRemaps(FlatBufferBuilder builder, int portRemapsOffset) { builder.addOffset(5, portRemapsOffset, 0); }
  public static int createPortRemapsVector(FlatBufferBuilder builder, int[] data) { builder.startVector(4, data.length, 4); for (int i = data.length - 1; i >= 0; i--) builder.addOffset(data[i]); return builder.endVector(); }
  public static void startPortRemapsVector(FlatBufferBuilder builder, int numElems) { builder.startVector(4, numElems, 4); }
  public static int endTreeNode(FlatBufferBuilder builder) {
    int o = builder.endTable();
    builder.required(o, 10);  // instance_name
    builder.required(o, 12);  // registration_name
    return o;
  }

  public static final class Vector extends BaseVector {
    public Vector __assign(int _vector, int _element_size, ByteBuffer _bb) { __reset(_vector, _element_size, _bb); return this; }

    public TreeNode get(int j) { return get(new TreeNode(), j); }
    public TreeNode get(TreeNode obj, int j) {  return obj.__assign(__indirect(__element(j), bb), bb); }
  }
}

